//  **** BEGIN LICENSE BLOCK ****
//  Copyright(c) 2005-2006 Adam Judson
//
//
//  PhotoMap
//  - display user contributed photos in a map
//
//  This program is free software; you can redistribute it and/or modify it under
//  the terms of the GNU General Public License as published by the Free
//  Software Foundation; either version 2 of the License, or (at your option)
//  any later version.
//
//  This program is distributed in the hope that it will be useful, but
//  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
//  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
//  more details.
//
//  You should have received a copy of the GNU General Public License along with
//  this program; if not, write to the Free Software Foundation, Inc., 59 Temple
//  Place, Suite 330, Boston, MA 02111-1307 USA
//
//  **** END LICENSE BLOCK ****


// the wrapper for our Yahoo map implementation
// has lots of problems...
function PhotoMapYMap(type) {
   this.init(type);
}

PhotoMapYMap.prototype = {
   __proto__ : new PhotoMapBaseMap(),

   getIncludes : function() {
      return '<script type="text/javascript" src="http://api.maps.yahoo.com/ajaxymap?v=2.0&appid=' + 
             this.preferences.getYahooAppid() + 
             '"></script>\n';
   },

   getOnload : function(homeLat, homeLon, homeZoom) {
      var onloadText =  '    function onLoad() {\n' +
                        '      document.getElementById("mapContainer").controller = photoMapController;\n' +
                        '      \n' +
                        '      var photoMap = new YMap(document.getElementById("mapContainer"));\n' +
                        '      photoMap.addPanControl();\n' +
                        '      photoMap.addZoomLong();\n' +
                        '      photoMapController.initMap(photoMap);\n' +
                        '      photoMapController.centerAndZoom(' + homeLat + ', ' + homeLon + ', ' + homeZoom + ');\n' +
                        '    }\n';
      return onloadText;
   },

   getController : function() {
      var controllerText =    '    function PhotoMapController() {\n' +
                              '      \n' +
                              '      this.initMap = function(photoMap) {\n' +
                              '         this.map = photoMap;\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.centerAndZoom = function(lat, lon, zoom) {\n' +
                              '         this.map.drawZoomAndCenter(new YGeoPoint(lat, lon), zoom);\n' +
                              '      };\n' +
                              '      \n' +
                              '      \n' +
                              '      this.getLocation = function() {\n' +
                              '         var centre = this.map.getCenterLatLon();\n' +
                              '         return {lat : centre.lat, lon : centre.lon};\n' +
                              '      };\n' +
                              '    }\n' +
                              '\n' +
                              'photoMapController = new PhotoMapController();\n';
      return controllerText;
   },

   ensureInit : function() {
      if (!this.mapController) {
         this.mapController = this.mapFrame.contentWindow.document.getElementById("mapContainer").wrappedJSObject.controller;
      }
   },

   setLocation : function(lat, lon, zoom) {
      this.mapController.centerAndZoom(lat, lon, zoom);
   }
};
